version: "3"
services:
  db:
      image: mongo:latest
      container_name: db
      ports:
        - "27017:27017"
      volumes:
        - dbdata:/data/db
      networks:
        - food-order-network

  redis-caching:
    image: redis:latest
    container_name: redis-caching
    command: redis-server --save 20 1 --loglevel warning
    ports:
      - "6379:6379"
    volumes:
      - cache:/data
    networks:
      - food-order-network

  product-service:
    working_dir: /app
    container_name: product-service
    build:
      context: .
      dockerfile: ./Dockerfile
      args:
        NODE_ENV: production
    ports:
      - "3003:3003"
    volumes:
      - ../upload:/app/upload
    env_file: .env

    external_links:
      - db
      - redis-caching
    networks:
      - food-order-network

    environment:
      PORT: 3003
      NODE_ENV: production
    command: node dist/app.js

  promethus:
    container_name: "prometheus"
    image: 'prom/prometheus'
    ports:
      - "9090:9090"
    volumes:
      - "./prometheus:/etc/prometheus"
    networks:
      - food-order-network

  grafana:
    image: grafana/grafana
    ports:
      - "3000:3000"
    volumes:
      - "./grafana-data:/var/lib/grafana"
    environment:
      GF_SECURITY_ADMIN_PASSWORD: secret
      GF_USERS_ALLOW_SIGN_UP: 'false'
    networks:
      - food-order-network

volumes:
  dbdata:
  cache:
  
networks:
  food-order-network:
    # external: true
